//
// Copyright (C) 2013..14 Falk Mueller
//
// mailbox@anfatec.de
// Falk Mueller
// Melanchthonstr. 28
// Oelsnitz
// D-08606
// Germany


unit Com;

interface

uses Windows, SysUtils, inifiles, ExtCtrls, Dialogs;

const
  RecBufSize = 2048;
  TrmBufSize = 2048;

var
  Cid: THandle;
  dcb: TDCB;
  UsedPort : integer;

procedure OpenComm();
procedure CloseCom;

procedure DataInBuffer(Cid: THandle; var InQueue, OutQueue: integer);
procedure WriteChar (value: Char);
procedure Write16BitInt (ch: Char; value: Integer);

implementation

uses
  Main;

procedure CloseCom;
begin
  // Stop reqests to Rainbowsourse
  // and empty buffer
  MainForm.Timer1.Enabled:=false;
  sleep(100);
  MainForm.Timer1Timer(MainForm);  // clear InQue
  if Cid<>INVALID_HANDLE_VALUE then begin
    CloseHandle(Cid);
    Cid:=INVALID_HANDLE_VALUE;
  end;
end;

procedure OpenComm();
var
  MyIni : TIniFile;
  s: String;
begin
  BuildCommDCB('baud=9600 parity=N data=8 stop=1',Com.dcb);

  // Which com port?
  MyIni := TIniFile.Create(MainForm.PathToIniFile + 'Com.ini');
  Com.UsedPort := MyIni.ReadInteger('Schnittstelle','COMx',1);
  MyIni.WriteInteger('Schnittstelle','COMx', UsedPort); // in case it was not there
  MyIni.Free;

  // Schnittstelle ffnen
  s := '\\.\COM' + IntToStr(UsedPort) + #0;

  Cid := CreateFile(@s[1],
    GENERIC_READ or GENERIC_WRITE,
    0,
    nil,
    OPEN_EXISTING,
    FILE_ATTRIBUTE_NORMAL,
    0);
  if (Cid <> INVALID_HANDLE_VALUE) then begin
    if (not SetupComm(Cid, RecBufSize, TrmBufSize)) then begin
      CloseHandle (Cid);
      Cid := INVALID_HANDLE_VALUE;
    end;
  end;
  if (Cid <> INVALID_HANDLE_VALUE) then begin
    // init comport
    if (not SetCommState(Cid, dcb)) then begin
      CloseHandle(Cid);
      Cid := INVALID_HANDLE_VALUE;
    end;
  end;
end;

procedure DataInBuffer(Cid: THandle; var InQueue, OutQueue: integer);
var
  ComStat : TComStat;
  e : cardinal;
begin
  if ClearCommError(Cid, e, @ComStat) then begin
    InQueue := ComStat.cbInQue;
    OutQueue := ComStat.cbOutQue;
  end else begin
    InQueue := 0;
    OutQueue := 0;
  end;
end;

procedure WriteChar(Value: Char);
var
  w: Cardinal;
  key: array[0..2] of char;
begin
  key[0] := value;
  WriteFile(Cid, key, 1, w, nil);
end;

procedure Write16BitInt(ch: Char; value: Integer);
var
  val16: Word;
  valKey: packed array[0..1] of char absolute val16;
  key: packed array[0..2] of char;
  w: cardinal;
begin
  if value > 65535 then  ShowMessage('Value too big!');
  if value < 0     then  ShowMessage('Value too small!');
  val16 := value;

  key[0] := ch;
  key[1] := valKey[0];
  key[2] := valKey[1];

  WriteFile(Cid,key,3,w,nil);
end;

procedure ProcessComReadBuffer;
const
  TempBufSize = 2048;
var
  InQue, OutQue: longint;
  ToRead, HasRead: cardinal;
  Buf: array[0..TempBufSize] of char;
begin
  if Cid=INVALID_HANDLE_VALUE then begin
    OpenComm();    //try again
    MainForm.Show;
    exit;
  end else begin
    MainForm.Hide;
  end;

  DataInBuffer(Cid, InQue, OutQue);
  if (InQue > 0) then  begin  // Daten stehen im Empfangspuffer
    ToRead := InQue;
    if (ToRead>TempBufSize) then ToRead:=TempBufSize;
    ReadFile(Cid, Buf, ToRead, HasRead, nil);
    Buf[HasRead]:=#0;
  end;
end;

end.
